<?php
use function React\Promise\all;

ini_set('max_execution_time', 600); //10 Minutes
include (dirname(__FILE__) . '/../../config/config.inc.php');
include (dirname(__FILE__) . '/../../init.php');

if (Tools::encrypt('SynSmsnotifications') == Tools::getValue('csrf')) {

	$sender_id = Configuration::get("SYN_SMS_NOTIFICATIONS_SENDER_ID");
	$api_key = Configuration::get("SYN_SMS_NOTIFICATIONS_API_TOKEN");
	$api_secret = Configuration::get("SYN_SMS_NOTIFICATIONS_API_SECRET");
	$api_url = Configuration::get("SYN_SMS_NOTIFICATIONS_API_URL");
	
	$routing_option = Configuration::get("SYN_SMS_NOTIFICATIONS_ROUTING_OPTION");
	
	
	
	$callback = Context::getContext()->shop->getBaseURL(true) . "modules/SynSmsnotifications/callback.php";

	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "changestate") {
		$id_template = Tools::getValue('id_template');
		$id_state = Tools::getValue('id_state');
		$id_lang = Tools::getValue('id_lang');
		$id_lang = Db::getInstance()->getValue("select id_lang from ps_lang where iso_code = '$id_lang'");
		$currentDateTime = date("Y-m-d H:i:s");

		if ($id_template == 0) {
			Db::getInstance()->execute("delete from syn_smsordertemplates where id_order_status = '$id_state' and id_lang = '$id_lang'");
		} else {
			$exist = Db::getInstance()->getValue("select id_order_status from syn_smsordertemplates where id_order_status = '$id_state' and id_lang = '$id_lang'");
			$test = "select id_order_status from syn_smsordertemplates where id_order_status = '$id_state' and id_lang = '$id_lang'";
			error_log(print_r($test, true));

			if (!empty($exist)) {
				Db::getInstance()->execute("update syn_smsordertemplates set id_template = '$id_template',update_date = '$currentDateTime' where id_order_status = '$id_state' and id_lang = '$id_lang'");
			} else {
				Db::getInstance()->execute("insert into syn_smsordertemplates (id_template,id_order_status,id_lang,create_date,update_date,active) values ('$id_template','$id_state','$id_lang','$currentDateTime','$currentDateTime','0')");
			}
		}
	}

	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "changeactive") {
		$id_state = Tools::getValue('id_state');
		$active = Tools::getValue('active');
		$id_lang = Tools::getValue('id_lang');
		$id_lang = Db::getInstance()->getValue("select id_lang from ps_lang where iso_code = '$id_lang'");

		$exist = Db::getInstance()->getValue("select id_order_status from syn_smsordertemplates where id_order_status = '$id_state'");

		if (!empty($exist)) {
			Db::getInstance()->execute("update syn_smsordertemplates set active = '$active' where id_order_status = '$id_state' and id_lang = '$id_lang'");
		}

	}

	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "gettemplate") {
		$id_template = Tools::getValue('id_temp');
		$template_message = Db::getInstance()->getValue("select sms from syn_smstemplates where id = '$id_template'");

		echo json_encode($template_message, JSON_UNESCAPED_UNICODE);
	}


	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "sendtestmsg") {
	
		
		$phone_number = Tools::getValue('tel');
		$text = Tools::getValue('text');
		$baseURL = (Configuration::get('PS_SSL_ENABLED') ? 'https://' : 'http://') . Tools::getShopDomain();
		if ($phone_number != '' && $text != '') {
			// $phone_number = '30' . $phone_number;
			if (substr($phone_number, 0, 3) !== '+30' && substr($phone_number, 0, 2) !== '30') {
				$phone_number = '30' . $phone_number;
			}
			$todayNumber = date('N');
			$inDays = Db::getInstance()->getValue("select days from modulus_time_rule where active = 1");
			$currentTimeWithoutSeconds = date('H:i');
			$timefrom = Db::getInstance()->getValue("select timefrom from modulus_time_rule");
			$timeto = Db::getInstance()->getValue("select timeto from modulus_time_rule");

			if (!empty($inDays)) {
				if (strpos($inDays, $todayNumber) !== false && ($currentTimeWithoutSeconds >= $timefrom && $currentTimeWithoutSeconds <= $timeto)) {
					$curl = curl_init();

					if ($routing_option == 'sms') {

						$curl = curl_init();

						curl_setopt_array(
							$curl,
							array(
								CURLOPT_URL => "$api_url",
								CURLOPT_RETURNTRANSFER => true,
								CURLOPT_ENCODING => '',
								CURLOPT_POST => 1,
								CURLOPT_MAXREDIRS => 10,
								CURLOPT_TIMEOUT => 0,
								CURLOPT_FOLLOWLOCATION => true,
								CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
								CURLOPT_CUSTOMREQUEST => 'POST',
								CURLOPT_POSTFIELDS => '{
	
								"priority": 3,
								"recipients": [
								  {
									"msisdn": "' . $phone_number . '"
								  }
								],
		  
								"sms": {
								"sender": "' . $sender_id . '",
								"text": "' . $text . '",
								  "encoding": "gsm",
								  "validityPeriod": 86400
		  
								},
								"dlr": true,
								"dlrUrl":  "' . $callback . '",
								"externalTags": [
								  "string"
								]
							  }',
								CURLOPT_HTTPHEADER => array(
									'Authorization: Bearer ' . $api_key,
									'Content-Type: application/json'
								),

							)
						);
					} else if ($routing_option == 'viber') {
						$curl = curl_init();

						curl_setopt_array(
							$curl,
							array(
								CURLOPT_URL => "$api_url",
								CURLOPT_RETURNTRANSFER => true,
								CURLOPT_ENCODING => '',
								CURLOPT_POST => 1,
								CURLOPT_MAXREDIRS => 10,
								CURLOPT_TIMEOUT => 0,
								CURLOPT_FOLLOWLOCATION => true,
								CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
								CURLOPT_CUSTOMREQUEST => 'POST',
								CURLOPT_POSTFIELDS => '{
	
									"routing": "viberTransactional",
									 "priority": 3,
									 "recipients": [
									   {
										 "msisdn": "' . $phone_number . '"
									   }
									 ],
									 "viber": {
									   "sender": "' . $sender_id . '",
									   "type": "text",
									   "validityPeriod": 86400,
									   "text": "' . $text . '",
										"encoding": "gsm"
									 
									 },
									
									 "dlr": true,
									 "dlrUrl": "' . $callback . '",
									 "externalTags": [
									   "string"
									 ]
								   }',
								CURLOPT_HTTPHEADER => array(
									'Authorization: Bearer ' . $api_key,
									'Content-Type: application/json'
								),

							)
						);
					} else if ($routing_option == 'viber2sms') {
						$curl = curl_init();

						curl_setopt_array(
							$curl,
							array(
								CURLOPT_URL => "$api_url",
								CURLOPT_RETURNTRANSFER => true,
								CURLOPT_ENCODING => '',
								CURLOPT_POST => 1,
								CURLOPT_MAXREDIRS => 10,
								CURLOPT_TIMEOUT => 0,
								CURLOPT_FOLLOWLOCATION => true,
								CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
								CURLOPT_CUSTOMREQUEST => 'POST',
								CURLOPT_POSTFIELDS => '{
	
									"routing": "viberTransactional2SMS",
									 "priority": 3,
									 "recipients": [
									   {
										 "msisdn": "' . $phone_number . '"
									   }
									 ],
									 "viber": {
									   "sender": "' . $sender_id . '",
									   "type": "text",
									   "validityPeriod": 86400,
									   "text": "' . $text . '",
										"encoding": "gsm"
									 
									 },
									 "sms": {
									   "sender": "' . $sender_id . '",
									   "text": "' . $text . '",
									   "encoding": "gsm",
									   "validityPeriod": 86400
									  
									 },
									 "dlr": true,
									 "dlrUrl": "' . $callback . '",
									 "externalTags": [
									   "string"
									 ]
								   }',
								CURLOPT_HTTPHEADER => array(
									'Authorization: Bearer ' . $api_key,
									'Content-Type: application/json'
								),

							)
						);
					}
					$response = curl_exec($curl);
					$response = json_decode($response, true);
					$messageId = $response['messages'][0]['messageId'];
					$code = $response['messages'][0]['status']['code'];
					$message = $response['messages'][0]['status']['message'];
					Db::getInstance()->execute("insert into modulus_logs (messageId,code,message,msisdn,message_text) values ('$messageId','$code','$message','$phone_number','$text')");

					curl_close($curl);
					echo json_encode($response);

				} else {

					Db::getInstance()->execute("insert into modulus_pending_message (phone_number,message,is_sent) values ('$phone_number','$text','0')");
				}
			} else {

				if ($routing_option == 'sms') {

					$curl = curl_init();

					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_POST => 1,
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{

							"priority": 3,
							"recipients": [
							  {
								"msisdn": "' . $phone_number . '"
							  }
							],
	  
							"sms": {
							"sender": "' . $sender_id . '",
							"text": "' . $text . '",
							  "encoding": "gsm",
							  "validityPeriod": 86400
	  
							},
							"dlr": true,
							"dlrUrl":  "' . $callback . '",
							"externalTags": [
							  "string"
							]
						  }',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),

						)
					);
				} else if ($routing_option == 'viber') {
					$curl = curl_init();

					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_POST => 1,
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{

								"routing": "viberTransactional",
								 "priority": 3,
								 "recipients": [
								   {
									 "msisdn": "' . $phone_number . '"
								   }
								 ],
								 "viber": {
								   "sender": "' . $sender_id . '",
								   "type": "text",
								   "validityPeriod": 86400,
								   "text": "' . $text . '",
									"encoding": "gsm"
								 
								 },
								
								 "dlr": true,
								 "dlrUrl": "' . $callback . '",
								 "externalTags": [
								   "string"
								 ]
							   }',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),

						)
					);
				} else if ($routing_option == 'viber2sms') {
					$curl = curl_init();

					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_POST => 1,
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{

								"routing": "viberTransactional2SMS",
								 "priority": 3,
								 "recipients": [
								   {
									 "msisdn": "' . $phone_number . '"
								   }
								 ],
								 "viber": {
								   "sender": "' . $sender_id . '",
								   "type": "text",
								   "validityPeriod": 86400,
								   "text": "' . $text . '",
									"encoding": "gsm"
								 
								 },
								 "sms": {
								   "sender": "' . $sender_id . '",
								   "text": "' . $text . '",
								   "encoding": "gsm",
								   "validityPeriod": 86400
								  
								 },
								 "dlr": true,
								 "dlrUrl": "' . $callback . '",
								 "externalTags": [
								   "string"
								 ]
							   }',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),

						)
					);
				}
				$response = curl_exec($curl);

				$response = json_decode($response, true);

				$messageId = $response['messages'][0]['messageId'];

				$code = $response['messages'][0]['status']['code'];

				$message = $response['messages'][0]['status']['message'];

				$httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

				if ($httpcode == 200) {

					Db::getInstance()->execute("insert into modulus_logs (messageId,code,message,msisdn,message_text) values ('$messageId','$code','$message','$phone_number','$text')");

					curl_close($curl);

				} else {
					$message = $response['message'];
				}
				echo $message;

			}



		}

	}


	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "sendmessages") {


		$message = Tools::getValue('message');
		$customers = Tools::getValue('customers');
		$customers = json_decode($customers, true);

		foreach ($customers as $num) {


			$placeholders = array("{first_name}", "{last_name}", "{order_id}", "{order_total}", "{shipping_number}");



			$mobile = Db::getInstance()->getValue("select phone from ps_address where id_customer = '$num' order by id_address desc");
			// ADD +30 IF IT DOES NOT EXIST TO THE MOBILE NUMBER

			if (substr($mobile, 0, 3) !== '+30' && substr($mobile, 0, 2) !== '30') {
				$mobile_phone = '30' . $mobile;
			}
			// $mobile_phone = '30' . $mobile;

			$todayNumber = date('N');
			$inDays = Db::getInstance()->getValue("select days from modulus_time_rule");
			$currentTimeWithoutSeconds = date('H:i');
			$timefrom = Db::getInstance()->getValue("select timefrom from modulus_time_rule");
			$timeto = Db::getInstance()->getValue("select timeto from modulus_time_rule");

			$customer = new Customer($num);
			$first_name = $customer->firstname;
			$last_name = $customer->lastname;


			$values = array($first_name, $last_name);

			$message = str_replace($placeholders, $values, $message);

			if ((strpos($inDays, $todayNumber) !== false && ($currentTimeWithoutSeconds >= $timefrom && $currentTimeWithoutSeconds <= $timeto)) || ($inDays == '' && $timefrom == '' && $timeto == '')) {
				
				if ($routing_option == 'sms') {
					$curl = curl_init();

					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{

						  "priority": 3,
						  "recipients": [
							{
							  "msisdn": "' . $mobile_phone . '"
							}
						  ],

						  "sms": {
							"sender": "' . $sender_id . '",
							"text": "' . $message . '",
							"encoding": "gsm",
							"validityPeriod": 86400

						  },
						  "dlr": true,
						  "dlrUrl":   "' . $callback . '",
						  "externalTags": [
							"string"
						  ]
						}',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),
						)
					);
				} else if ($routing_option == 'viber') {
					$curl = curl_init();

					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_POST => 1,
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{
			
							"routing": "viberTransactional",
							"priority": 3,
							"recipients": [
							{
							"msisdn": "' . $mobile_phone . '"
							}
							],
							"viber": {
							"sender": "' . $sender_id . '",
							"type": "text",
							"validityPeriod": 86400,
							"text": "' . $message . '",
							"encoding": "gsm"
							
							},
							
							"dlr": true,
							"dlrUrl": "' . $callback . '",
							"externalTags": [
							"string"
							]
							}',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),

						)
					);
				}else if ($routing_option == 'viber2sms') {
					$curl = curl_init();
				
					curl_setopt_array(
						$curl,
						array(
							CURLOPT_URL => "$api_url",
							CURLOPT_RETURNTRANSFER => true,
							CURLOPT_ENCODING => '',
							CURLOPT_POST => 1,
							CURLOPT_MAXREDIRS => 10,
							CURLOPT_TIMEOUT => 0,
							CURLOPT_FOLLOWLOCATION => true,
							CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
							CURLOPT_CUSTOMREQUEST => 'POST',
							CURLOPT_POSTFIELDS => '{
				
							"routing": "viberTransactional2SMS",
							"priority": 3,
							"recipients": [
							{
							"msisdn": "' . $mobile_phone . '"
							}
							],
							"viber": {
							"sender": "' . $sender_id . '",
							"type": "text",
							"validityPeriod": 86400,
							"text": "' . $message . '",
							"encoding": "gsm"
							
							},
							"sms": {
							"sender": "' . $sender_id . '",
							"text": "' . $message . '",
							"encoding": "gsm",
							"validityPeriod": 86400
							
							},
							"dlr": true,
							"dlrUrl": "' . $callback . '",
							"externalTags": [
							"string"
							]
							}',
							CURLOPT_HTTPHEADER => array(
								'Authorization: Bearer ' . $api_key,
								'Content-Type: application/json'
							),
				
						)
					);
				}
				$response = curl_exec($curl);
				$response = json_decode($response, true);
				$messageId = $response['messages'][0]['messageId'];
				$code = $response['messages'][0]['status']['code'];
				$message_response = $response['messages'][0]['status']['message'];
				Db::getInstance()->execute("insert into modulus_logs (messageId,code,message,msisdn,message_text) values ('$messageId','$code','$message_response','$mobile_phone','$message')");
				curl_close($curl);
				echo json_encode($response, JSON_UNESCAPED_UNICODE);
			} else {

				Db::getInstance()->execute("insert into modulus_pending_message (phone_number,message,is_sent) values ('$mobile_phone','$message','0')");
				//return json_encode($response);
			}


		}
	}

	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "addrule") {
		$days = Tools::getValue('days');
		$startTime = Tools::getValue('starttime');
		$endTime = Tools::getValue('endtime');
		$status = Tools::getValue('status');
		$daysStr = implode(",", $days);

		$existrule = Db::getInstance()->getValue("select days from modulus_time_rule");

		if (empty($existrule)) {
			Db::getInstance()->execute("insert into modulus_time_rule (days,timefrom,timeto,active) values ('$daysStr','$startTime','$endTime','0')");
		} else {

			// error_log("UPDATE modulus_time_rule SET days='$daysStr' , timefrom='$startTime', timeto='$endTime', active='0' WHERE id_rule=1");
			Db::getInstance()->execute("UPDATE modulus_time_rule SET days='$daysStr' , timefrom='$startTime', timeto='$endTime', active='$status' WHERE id_rule=1");
		}
	}

	if (Tools::getValue('ajax') && Tools::getValue('ajax') == "notify") {
		$telephone = Tools::getValue('tel');
		$id_lang = Tools::getValue('id_lang');
		$id_product = Tools::getValue('id_product');
		$id_product_attribute = Tools::getValue('id_product_attribute');

		$exist = Db::getInstance()->getValue("select product_id from modulus_back_in_stock where product_id = '$id_product' and phone_number = '$telephone'");
		if (empty($exist)) {

			Db::getInstance()->execute("insert into modulus_back_in_stock (product_id,id_product_attribute,phone_number,id_lang,notify_id) values ('$id_product','$id_product_attribute','$telephone','$id_lang','0')");
		}
	}


	if (!Tools::getValue('ajax')) {
		header('Location: ' . $_SERVER['HTTP_REFERER']);
	}


} else {
	echo "badtoken";
}

?>