<style>
    label.messages {
        margin-top: 10px;
    }

    .card.syn-order-sms button.btn.btn-primary {
        margin-top: 20px;
    }

    .syn-order-sms-filter.active,
    .syn-order-sms-popup.active {
        display: block;
    }

    .syn-order-sms-filter {
        position: fixed;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background: #00000054;
        z-index: 9998;
        display: none;
    }

    .syn-order-sms-popup {
        position: fixed;
        background: white;
        padding: 20px;
        width: 30vw;
        height: 60vh;
        top: 20vh;
        left: 35vw;
        z-index: 9999;
        border-radius: 5px;
        display: none;
    }

    a#edit_sms_templatess img {
        height: 20px;
        margin-left: 10px;
    }

    a#edit_sms_templatess {
        display: flex;
        color: #25b9d7;
        float: right;
        cursor: pointer;
    }

    button#syn_order_sms_close_popup {
        position: absolute;
        top: 10px;
        right: 10px;
        padding: 0;
        background: unset;
        border-radius: 50%;
        border: 1px solid gainsboro;
        cursor: pointer;
    }

    .sms-template-list {
        max-height: calc(60vh - 80px);
        overflow: auto;
    }

    .sms-template-list .sms-template>img {
        height: 20px;
        cursor: pointer;
    }

    .sms-template-list .sms-template {
        display: flex;
        align-items: center;
        justify-content: space-between;
        padding: 5px 10px;
    }

    .sms-template-details textarea {
        width: 100%;
        height: 100px;
        border: 1px solid #eaeaea;
        padding: 5px;
    }

    .sms-template-details {
        display: none;
    }

    .sms-template .sms-left-container {
        width: calc(100% - 50px);
    }

    .sms-template {
        display: flex;
        align-items: center;
        justify-content: space-between;
        padding: 5px 10px;
        border-bottom: 1px solid #eaeaea;
    }

    input.sms-template-title:disabled {
        background: white;
        border: unset;
    }

    input.sms-template-title {
        width: 70%;
        border: unset;
        border: 1px solid #cecece;
        padding: 3px 5px;
        border-radius: 2px;
    }

    .sms-template-list .sms-template.edited {
        border: unset;
    }

    .sms-template-details.edited label {
        margin: 0px 5px 5px 5px;
        font-size: 15px;
    }

    .sms-template-save {
        display: none;
    }

    .edited .sms-template-save {
        display: block
    }

    .sms-template.edited img.sms-template-edit {
        display: none;
    }

    .sms-template-details.edited {
        padding: 5px;
        background: #f3f3f3;
        display: block;
    }

    button.add-sms-template.btn {
        position: absolute;
        bottom: 15px;
        right: 15px;
    }

    span.form-description {
        display: block;
        color: #9e9e9e;
    }

    .sms-history:nth-child(2n) {
        background: #f7f3f3;
    }

    .sms-history>* {
        width: 100%;
    }

    .sms-history {
        display: flex;
        align-items: center;
        justify-content: space-between;
        background: #eaeaea;
        padding: 10px;
    }

    .sms-history span.message {
        max-height: 60px;
        overflow: auto;
    }

    .sms-history:last-of-type {
        margin-bottom: 20px;
    }

    .sms-template-delete {
        margin-left: 10px;
    }
</style>
<div class="card syn-order-sms mt-2">
    <div class="card-header">
        <h3 class="card-header-title">
            SMS {if !empty($sms_history)}({$sms_history|sizeof}){/if}
        </h3>
    </div>
    <div class="card-body">

        <form action="{$link->getAdminLink('AdminSMSNotifications')}" method="post">
            <input type="hidden" name="action" value="send-sms">
            <input type="hidden" name="id_order" value="{$id_order}">
            <input type="hidden" name="id_customer" value="{$id_customer}">

            <label>Επιλέξτε πρώτυπο SMS</label>

            <a id="edit_sms_templatess">
                Επεξεργασία πρότυπων
                <img src="/modules/SynSmsnotifications/views/imgs/template.svg">
            </a>
            <select id="select_sms_template" class="custom-select">
                <option value="">-</option>
                {foreach $templates as $template}
                    <option value="{$template.id}">{$template.title_sms}</option>
                {/foreach}
            </select>
            <div>
                {assign var="type" value="order"}
                {include file="module:SynSmsnotifications/views/templates/sms_write_instructions.tpl" type=$type}

                <label class="messages"><span class="text-danger">*</span>Τηλέφωνο πελάτη</label>
                <div class="input-group">
                    <input type="text" name="sms-phone" class="form-control" value="{$phones}">
                </div>
                <span class="form-description">Η μορφή του τηλεφώνου για Ελλάδα είναι 3069ΧΧΧΧΧΧΧΧ</span>

                <label class="messages"><span class="text-danger">*</span>Μήνυμα</label>

                <div class="input-group js-text-with-length-counter">
                    <textarea id="order_sms" name="sms-content" required="required" cols="30" rows="3"
                        class="js-countable-input form-control"></textarea>

                </div>
                <div style="display:flex;margin-bottom:1em;gap:2px;">
                    <div id="character_count"></div>
                    <div id="character_warning"></div>
                </div>

                <div class="text-right">
                    <button type="submit" class="btn btn-primary">Στείλε SMS</button>
                </div>
        </form>

        <form action="" method="POST" id="again_send">
            {if !empty($sms_history)}
                <h4>Ιστορικό SMS</h4>
            {/if}
            {foreach $sms_history as $sms}
                <div class="sms-history">

                    <span>{$sms.phone}</span>
                    <span class="message">{$sms.message}</span>
                    <span>{$sms.date_add}</span>
                    <input type="hidden" name="phone_num" value="{$sms.phone}">
                    <input type="hidden" name="sms" value="{$sms.message}">
                    <input type="hidden" name="id_customer_again" value="{$id_customer}">
                    <button type="submit" name="again_send" class="btn btn-primary">Επαναποστολή</button>
                </div>
            {/foreach}
        </form>

    </div>
</div>

<div class="syn-order-sms-filter"></div>
{include file='./sms-customer-templates-popup.tpl' templates=$templates}

<script>
    jQuery("#order_sms").on("input", function() {

        var charCount = jQuery(this).val().length;

        var result;

        if (charCount >= 160 && charCount <= 306) {
            result = 2;
        } else if (charCount > 306) {
            result = Math.ceil((charCount - 306) / 156) + 2;
        } else {
            result = 1;
        }

        jQuery("#character_count").html(
            "<strong>" + charCount + "</strong>" + " Χαρακτήρες"
        );

        jQuery("#character_warning").html(
            "Το μήνυμα θα αποσταλεί σε <strong>" + result + " </strong> SMS."
        );

    });



    var syn_sms_notifications_ajax_url = '{$link->getAdminLink('AdminSMSNotifications')}';
    $(document).ready(function() {

        $('a#edit_sms_templatess').click(function() {
            $('.syn-order-sms-filter').fadeIn();
            $('.syn-order-sms-popup').fadeIn();
        });

        $('.syn-order-sms-filter').click(function() {
            $('.syn-order-sms-filter').fadeOut();
            $('.syn-order-sms-popup').fadeOut();
        });




        function buildSMSTemplateListListeners() {

            $('#syn_order_sms_close_popup').click(function() {
                $('.syn-order-sms-filter').fadeOut();
                $('.syn-order-sms-popup').fadeOut();
            });

            $('.sms-template img.sms-template-edit').click(function() {
                let id_template = $(this).attr('data-template-id');
                $('.sms-template[data-template-id="' + id_template + '"]').toggleClass('edited');
                $('.sms-template-title[data-template-id="' + id_template + '"]').prop('disabled',
                    false);
                $('.sms-template-details[data-template-id="' + id_template + '"]').toggleClass(
                    'edited');
            });

            $('img.sms-template-save').click(function() {
                let id_template = $(this).attr('data-template-id');
                let sms_text = $('.sms-template-details[data-template-id="' + id_template +
                    '"] textarea').val();
                let sms_title = $('.sms-template-title[data-template-id="' + id_template + '"]').val();
                $.ajax({
                    type: 'POST',
                    url: syn_sms_notifications_ajax_url,
                    data: {
                        ajax: true,
                        controller: "AdminSMSNotifications",
                        action: "updateSMSTemplate",
                        id_template: id_template,
                        sms_text: sms_text,
                        sms_title: sms_title,
                    },
                    success: function(data) {
                        jsonData = JSON.parse(data);
                        if (jsonData.success) {
                            $('.sms-template[data-template-id="' + id_template + '"]')
                                .toggleClass('edited');
                            $('.sms-template-title[data-template-id="' + id_template + '"]')
                                .prop('disabled', true);
                            $('.sms-template-details[data-template-id="' + id_template +
                                '"]').toggleClass('edited');
                        }
                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        //jAlert("TECHNICAL ERROR: Details:Error thrown: " + XMLHttpRequest + "" + 'Text status: ' + textStatus);
                    }
                });
            });

            $('img.sms-template-delete').click(function() {
                let id_template = $(this).attr('data-template-id');
                $.ajax({
                    type: 'POST',
                    url: syn_sms_notifications_ajax_url,
                    data: {
                        ajax: true,
                        controller: "AdminSMSNotifications",
                        action: "deleteSMSTemplate",
                        id_template: id_template,
                    },
                    success: function(data) {
                        jsonData = JSON.parse(data);
                        if (jsonData.success) {
                            refreshSMSTemplateList();
                        }
                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        //jAlert("TECHNICAL ERROR: Details:Error thrown: " + XMLHttpRequest + "" + 'Text status: ' + textStatus);
                    }
                });
            });
        }

        //first load of the page
        buildSMSTemplateListListeners();

        function refreshSMSTemplateList() {
            $.ajax({
                type: 'POST',
                url: syn_sms_notifications_ajax_url,
                data: {
                    ajax: true,
                    controller: "AdminSMSNotifications",
                    action: "getSMSTemplateList",
                },
                success: function(data) {
                    jsonData = JSON.parse(data);

                    html = `
                  <button id="syn_order_sms_close_popup"><i class="material-icons">close</i></button>
                  <h3>Πρότυπα SMS</h3>
                  <div class="sms-template-list">`;

                    for (var i = 0; i < jsonData.templates.length; i++) {
                        let template = jsonData.templates[i];
                        html += `
                        <div class="sms-template" data-template-id="` + template.id + `">
                          <div class="sms-left-container">
                            <span class="sms-template-id">` + template.id + ` )</span>
                            <input class="sms-template-title" type="text" value="` + template.title_sms + `" disabled
                                   data-template-id="` + template.id + `">
                          </div>
                          <img class="sms-template-edit" src="/modules/SynSmsnotifications/views/imgs/edit.svg"
                               data-template-id="` + template.id + `">
                          <img class="sms-template-save" src="/modules/SynSmsnotifications/views/imgs/save.svg"
                               data-template-id="` + template.id + `">
						  <img class="sms-template-delete" src="/modules/SynSmsnotifications/views/imgs/delete.svg"
                               data-template-id="` + template.id + `">
                        </div>
                        <div class="sms-template-details" data-template-id="` + template.id + `">
                          <label>Μήνυμα</label>
                          <textarea data-template-id=""` + template.id + `">` + template.sms + `"</textarea>
                        </div>
                   `;
                    }
                    html += `
                    <button class="add-sms-template btn">Προσθήκη πρότυπου</button>
                  </div>
                `;

                    $('.syn-order-sms-popup').html(html);
                    buildSMSTemplateListListeners();
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    //jAlert("TECHNICAL ERROR: Details:Error thrown: " + XMLHttpRequest + "" + 'Text status: ' + textStatus);
                }
            });
        }

        $('button.add-sms-template.btn').click(function() {
            $.ajax({
                type: 'POST',
                url: syn_sms_notifications_ajax_url,
                data: {
                    ajax: true,
                    controller: "AdminSMSNotifications",
                    action: "addSMSTemplate",
                },
                success: function(data) {
                    jsonData = JSON.parse(data);
                    if (jsonData.success) {
                        refreshSMSTemplateList();
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    //jAlert("TECHNICAL ERROR: Details:Error thrown: " + XMLHttpRequest + "" + 'Text status: ' + textStatus);
                }
            });
        });
        $('select#select_sms_template').click(function() {
            let id_template = $(this).val();
            $.ajax({
                type: 'POST',
                url: syn_sms_notifications_ajax_url,
                data: {
                    ajax: true,
                    controller: "AdminSMSNotifications",
                    action: "getSMSTemplateContent",
                    id_template: id_template
                },
                success: function(data) {
                    jsonData = JSON.parse(data);
                    $('textarea#order_sms').html(jsonData.sms)
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    //jAlert("TECHNICAL ERROR: Details:Error thrown: " + XMLHttpRequest + "" + 'Text status: ' + textStatus);
                }
            });
        });
    });
</script>