<style>
  .pagination {
    text-align: center;
    margin-top: 20px;
  }

  .pagination button {
    padding: 10px 20px;
    background-color: #007BFF;
    color: #fff;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    margin: 0 5px;
    transition: background-color 0.3s ease;
  }

  .pagination button:hover {
    background-color: #3DA9B0;
  }

  .pagination button:disabled {
    background-color: #ccc;
    cursor: not-allowed;
  }

  .btn-secondary {
    background-color: #007BFF;
    color: #fff;
    border: none;
    border-radius: 5px;
    padding: 10px 20px;
    cursor: pointer;
    transition: background-color 0.3s ease;
  }

  .btn-secondary:hover {
    background-color: #3DA9B0;
  }

  a#edit_sms_templatess img {
    height: 20px;
    margin-left: 10px;
  }
</style>


<div class="panel">
  <div class="panel-heading">
    {assign var="active" value="mass_send"}
    {include file="module:SynSmsnotifications/views/templates/admin_tabs.tpl" active=$active}
    <br>
  </div>
  <div class="panel-body" style="margin-left: -27px">
    <div class="form-group">

      <div class="container-fluid">
        <form action="" method="POST" id="submitnamesearch" style="display: flex; margin-bottom:31px;">
          <label for="searchbrandsbox" style="margin-top: 10px;
		margin-right: 10px; margin-left: 0px; ">Αναζήτηση με όνομα η επώνυμο πελάτη:</label>
          <input type="text" id="searchnamebox" style="width: 170px;" name="search_query"
            placeholder="Αναζήτηση πελάτη...">
          <span class="icon-input-btn" style="margin-left: 20px;"><input type="submit" name="submitnamesearch"
              class="btn btn-secondary submitnamesearch" value="Αναζήτηση"></span>
        </form>

        <table class="table">
          <thead>
            <tr>
              <th scope="col" class="col-sm"><input type="checkbox" id="check_all"></th>
              <th scope="col" class="col-sm">ID πελάτη</th>
              <th scope="col" class="col-sm">Όνομα</th>
              <th scope="col" class="col-sm">Επώνυμο</th>
              <th>Τηλέφωνο</th>
              <th>E-mail</th>
              <th scope="col" class="col-sm">Group Πελατών</th>
              <th scope="col" class="col-sm">Γλώσσα</th>
              <th scope="col" class="col-sm" style="display:none!important;">Ιστορικό</th>
            </tr>
          </thead>
          <form action="" method="post">
            {foreach from=$customers item=item}

              <tr value={$item.id_customer} name="val" id={$item.id_customer}>
                <td class="col-sm">
                  <div class="form-check">
                    <input type="checkbox" class="form-check-input" name="selected_customers[]"
                      value="{$item.id_customer}">
                  </div>
                </td>
                <td class="col-sm getid" id="id" value="{$item.id_customer}" style="height: 50px;">{$item.id_customer}
                </td>

                <td class="col-sm gettitle_sms" id="title_sms" value="{$item.firstname}" style="height: 50px;">
                  {$item.firstname}</td>
                <td class="col-sm gettitle_sms_text" id="sms" value="{$item.lastname}" style="height: 50px;">
                  {$item.lastname}</td>


                <td class="col-sm get_phone_sms" id="title_sms" value="{$item.phone}" style="height: 50px;">
                  {$item.phone}</td>
                <td class="col-sm get_email_text" id="sms" value="{$item.email}" style="height: 50px;">
                  {$item.email}</td>

                <td class="col-sm gettitle_sms_lang" id="lang" value="{$item.groups}" style="height: 50px;">{$item.groups}
                </td>
                <td class="col-sm get_creation_date" id="creation_date" value="{$item.id_lang}" style="height: 50px;">
                  {$item.iso}</td>

                <td class="col-sm get_history" id="creation_history" value="{$item.id_customer}"
                  style="height: 50px;display:none!important;">
                  <button id="{$item.id_customer}" data-customer-id="{$item.id_customer}"></button>
                </td>

                <input type="hidden" name="sms_id" id="sms_id" value="{$item.id}">
                <input type="hidden" name="sms_text" id="sms_text" value="{$item.title_sms}">



              {/foreach}


        </table>
        <div class="pagination">
          <button id="prevPage">Previous</button>
          <button id="nextPage">Next</button>
        </div>
      </div>
    </div>
  </div>
</div>
<div class="panel container-fluid">
  <div class="panel-body" style="">

    <input type="hidden" name="action" value="send-sms">
    <input type="hidden" name="id_order" value="{$id_order}">
    <input type="hidden" name="id_customer" value="{$id_customer}">

    <label>Επιλέξτε πρώτυπο SMS</label>


    <select id="select_sms_template" class="custom-select">
      <option value="">-</option>
      {foreach $smsarray as $template}
        <option value="{$template.id}">{$template.title_sms}</option>
      {/foreach}
    </select><br>
    {assign var="type" value="user"}
    {include file="module:SynSmsnotifications/views/templates/sms_write_instructions.tpl" type=$type}

    <label class="messages"><span class="text-danger">*</span>Μήνυμα</label>
    <div class="input-group " style="width:100%;margin-bottom:1em;">
      <textarea id="order_sms" name="sms-content" required="required" rows="3"
        class="js-countable-input form-control"></textarea>
    </div>


    <div class="text-right">
      <button type="button" class="btn btn-primary" name="sendmasssms" id="sendmasssms"
        style="background:black!important;color:white;border-color:black;">Αποστολή</button>
    </div>
  </div>
</div>
<script>
  var csrfToken = '{$csrf}';
  document.addEventListener("DOMContentLoaded", function() {
    let check_all = document.getElementById('check_all');
    check_all.addEventListener('change', (event) => {
      const selected_customers = document.getElementsByName('selected_customers[]');
      selected_customers.forEach((checkbox) => {
        if (event.currentTarget.checked) {
          checkbox.checked = true;
        } else {
          checkbox.checked = false;
        }
      })

    })
    const rows = document.querySelectorAll("tr[name='val']");
    const rowsPerPage = 20;
    let currentPage = 0;

    function showPage(page) {
      rows.forEach((row, index) => {
        if (index >= page * rowsPerPage && index < (page + 1) * rowsPerPage) {
          row.style.display = "table-row";
        } else {
          row.style.display = "none";
        }
      });
    }

    function updateButtons() {
      document.getElementById("prevPage").disabled = currentPage === 0;
      document.getElementById("nextPage").disabled =
        currentPage >= rows.length / rowsPerPage - 1;
    }

    showPage(currentPage);
    updateButtons();

    document.getElementById("prevPage").addEventListener("click", () => {
      if (currentPage > 0) {
        currentPage--;
        showPage(currentPage);
        updateButtons();
      }
    });

    document.getElementById("nextPage").addEventListener("click", () => {
      if (currentPage < Math.ceil(rows.length / rowsPerPage) - 1) {
        currentPage++;
        showPage(currentPage);
        updateButtons();
      }
    });

  });
  $(document).ready(function() {
    $('select#select_sms_template').click(function() {
      let id_template = $(this).val();
      $.ajax({
        type: "GET",
        url: "/modules/SynSmsnotifications/Processor.php",
        data: {
          id_temp: id_template,
          csrf: csrfToken,
          ajax: "gettemplate"
        },
        success: function(data) {

          jsonData = JSON.parse(data);

          $('textarea#order_sms').html(jsonData)
        }
      });
    });

    $('#sendmasssms').click(function(event) {

      var smsContent = $('textarea#order_sms').val();
      var selectedCustomers = [];
      $('input.form-check-input:checked').each(function() {
        selectedCustomers.push($(this).val());
      });

      var selectedCustomersJSON = JSON.stringify(selectedCustomers);
      console.log(selectedCustomersJSON);


      $.ajax({
        type: "GET",
        url: "/modules/SynSmsnotifications/Processor.php",
        data: {
          message: smsContent,
          customers: selectedCustomersJSON,
          csrf: csrfToken,
          ajax: "sendmessages"
        },
        success: function(data) {
          console.log(data);
        }
      });

    });

  });
</script>